namespace Programming_CSharp
{
	using System;
	using System.IO;
	using System.Threading;
	using System.Text;

	public class AsynchIOTester
	{
		private Stream inputStream;   
    
		// ӵ ޼ҵ
		private AsyncCallback myCallBack; 

		//  ͸ ϴ 
		private byte[] buffer;         
 
		//  ũ 
		const int BufferSize = 256;

		// 
		AsynchIOTester()
		{
			// Է Ʈ Ѵ.
			inputStream = 
				File.OpenRead(
				@"C:\test\source\AskTim.txt");

			// ۸ ҴѴ.
			buffer = new byte[BufferSize];

			// ݹ Ѵ. 
			myCallBack = 
				new AsyncCallback(this.OnCompletedRead);
		}

		public static void Main()
		{
			// AsynchIOTester νϽ ϰ,
			// AsynchIOTester ڸ ȣѴ. 
			AsynchIOTester theApp = 
				new AsynchIOTester();           

			// νϽ ޼ҵ带 ȣѴ. 
			theApp.Run(  );
		}

		void Run(  )
		{
			inputStream.BeginRead(
				buffer,             //  Ѵ. 
				0,                  // 
				buffer.Length,      //  ũ
				myCallBack,         //    
				null);              //   ü

			// ͸ д   ٸ ۾
			for (long i = 0; i < 500000; i++)        
			{
				if (i%1000 == 0)
				{
					Console.WriteLine("i: {0}", i);
				}
			}
            
		}

		// ݹ ޼ҵ
		void OnCompletedRead(IAsyncResult asyncResult)
		{
			int bytesRead = 
				inputStream.EndRead(asyncResult);

			// ͸ , Ʈ ȯ  ȭ鿡 Ѵ.
			// ׸  ٽ ϸ, 
			//  Ͱ  Ѵ.
			if (bytesRead > 0)
			{
				String s = 
					Encoding.ASCII.GetString(buffer, 0, bytesRead);
				Console.WriteLine(s);
				inputStream.BeginRead(
					buffer, 0, buffer.Length, myCallBack, null);
			}
		}
	}
}

