namespace Programming_CSharp
{
 	using System;
	using System.Collections;

	// 迭 Ǵ  Ŭ
	public class Employee : IComparable
	{
		public Employee(int empID)
		{
			this.empID = empID;
		}

		public Employee(int empID, int yearsOfSvc)
		{
			this.empID = empID;
			this.yearsOfSvc = yearsOfSvc;
		}

		public override  string ToString()
		{
			return "ID: " + empID.ToString() + 
			". Years of Svc: " + yearsOfSvc.ToString();
		}

		// Comparer ü   ޼ҵ 
		public static EmployeeComparer GetComparer()
		{
			return new Employee.EmployeeComparer();
		}

		// Comparer Employee Ѵ.
		// Employee  ⺻ Ǵ
		// CompareTo ޼ҵ带 Ѵ.
		public int CompareTo(Object rhs)
		{
			Employee r = (Employee) rhs;
			return this.empID.CompareTo(r.empID);
		}

		//   Comparer  ȣǴ κ
		public int CompareTo(
			Employee rhs, 
			Employee.EmployeeComparer.ComparisonType which)
		{
			switch (which)
			{
				case Employee.EmployeeComparer.ComparisonType.EmpID:
					return this.empID.CompareTo(rhs.empID);
				case Employee.EmployeeComparer.ComparisonType.Yrs:
					return this.yearsOfSvc.CompareTo(rhs.yearsOfSvc);
			}
			return 0;

		}

		// IComparer ϴ ø Ŭ
		public class EmployeeComparer : IComparer
		{
			// ComparisionType  
			public enum ComparisonType
			{
				EmpID,
				Yrs
			};

			// Employee ü ü ڽ ϶ Ѵ. 
			public int Compare(object lhs, object rhs)
			{
				Employee l = (Employee) lhs;
				Employee r = (Employee) rhs;
				return l.CompareTo(r,WhichComparison);
			}

			public Employee.EmployeeComparer.ComparisonType 
				WhichComparison
			{
				get
				{
					return whichComparison;
				}
				set
				{
					whichComparison=value;
				}
			}

			//    
			private Employee.EmployeeComparer.ComparisonType 
				whichComparison;
		}
		private int empID;
		private int yearsOfSvc = 1;
	}
	public class Tester
	{
		static void Main()
		{
			ArrayList empArray = new ArrayList();


			//   ID  
			//  Ѵ.
			Random r = new Random();

			// 迭 Ѵ.
			for (int i = 0;i<5;i++)
			{
				//   ID ߰Ѵ.
				empArray.Add(
					new Employee(
						r.Next(10)+100,r.Next(20)
					)
				);
			}
         
			// Employee 迭 ִ   Ѵ.
			for (int i = 0;i<empArray.Count;i++)
			{
				Console.Write("\n{0} ", empArray[i].ToString());
			}
				Console.WriteLine("\n");

			// ϰ   迭 Ѵ.
			Employee.EmployeeComparer c = Employee.GetComparer();
			c.WhichComparison=Employee.EmployeeComparer.ComparisonType.EmpID;
			empArray.Sort(c);
			// Employee 迭   Ѵ.
			for (int i = 0;i<empArray.Count;i++)
			{
				Console.Write("\n{0} ", empArray[i].ToString());
			}
			Console.WriteLine("\n");

			c.WhichComparison=Employee.EmployeeComparer.ComparisonType.Yrs;
			empArray.Sort(c);
			for (int i = 0;i<empArray.Count;i++)
			{
				Console.Write("\n{0} ", empArray[i].ToString());
			}
			Console.WriteLine("\n");


		}
	}
}

