namespace Programming_CSharp
{
	using System;
	using System.Reflection;
 
// Ŭ  Ҵ   Ӽ Ѵ.
	[AttributeUsage(AttributeTargets.Class |
		AttributeTargets.Constructor |
		AttributeTargets.Field |
		AttributeTargets.Method |
		AttributeTargets.Property,
		AllowMultiple = true)]
	public class BugFixAttribute : System.Attribute
	{
		// ġ Ű  Ӽ  
		public BugFixAttribute
			(int bugID, 
			string programmer, 
			string date)
		{
			this.bugID = bugID;
			this.programmer = programmer;
			this.date = date;
		}
 
		// 
		public int BugID
		{
			get
			{
				return bugID;
			}
		}
 
		// ̸ ִ Ű  Ƽ
		public string Comment
		{
			get
			{
				return comment;
			}
			set
			{
				comment = value;
			}
		}
 
		// 
		public string Date
		{
			get
			{
				return date;
			}
		}
 
		// 
		public string Programmer
		{
			get
			{
				return programmer;
			}
		}
        
		//    
		private int     bugID;
		private string  comment;
		private string  date;
		private string  programmer;
	}
 
 
	// ********* Ŭ Ӽ Ҵ ********
 
	[BugFixAttribute(121,"Jesse Liberty","01/03/05")]
	[BugFixAttribute(107,"Jesse Liberty","01/04/05", 
		Comment="Fixed off by one errors")]
	public class MyMath
	{
        
		public double DoFunc1(double param1)
		{
			return param1 + DoFunc2(param1);           
		}
 
		public double DoFunc2(double param1)
		{           
			return param1 / 3;
		}
    
	}
 
	public class Tester
	{
		public static void Main()
		{
			MyMath mm = new MyMath();
			Console.WriteLine("Calling DoFunc(7). Result: {0}",
				mm.DoFunc1(7));
		}        
	}
}
 
