namespace Programming_CSharp
{
   using System;
   using System.IO;
   using System.Runtime.InteropServices;

   class Tester
   {

      // P/Invoke ȣϷ WinAPI ޼ҵ 
      [DllImport("kernel32.dll", EntryPoint="MoveFile",
          ExactSpelling=false, CharSet=CharSet.Unicode,
          SetLastError=true)]
      static extern bool MoveFile(
         string sourceFile, string destinationFile);

      public static void Main(  )
      {
         // νϽ Ͽ Ѵ.
         Tester t = new Tester(  );
         string theDirectory = @"c:\test\media";
         DirectoryInfo dir = 
            new DirectoryInfo(theDirectory);
         t.ExploreDirectory(dir);
      }
        
      // 丮 ̸ Ͽ Ѵ.
      private void ExploreDirectory(DirectoryInfo dir)
      {

         //   丮 .
         string newDirectory = "newTest";
         DirectoryInfo newSubDir = 
            dir.CreateSubdirectory(newDirectory);

         // 丮    ο 丮 Ѵ.
         FileInfo[] filesInDir = dir.GetFiles(  );
         foreach (FileInfo file in filesInDir)
         {
            string fullName = newSubDir.FullName +  
               "\\" + file.Name;
            file.CopyTo(fullName);
            Console.WriteLine("{0} copied to newTest", 
               file.FullName);
         }

         //  ϵ ÷ ´.
         filesInDir = newSubDir.GetFiles(  );

         // Ϻδ ϰ  ̸ ٲ۴.
         int counter = 0;
         foreach (FileInfo file in filesInDir)
         {
            string fullName = file.FullName;

            if (counter++ %2 == 0)
            {
               // P/Invoke Win API ȣѴ.
               Tester.MoveFile(fullName, fullName + ".bak");
               
               Console.WriteLine("{0} renamed to {1}",
                  fullName,file.FullName);
            }
            else
            {
               file.Delete(  );
               Console.WriteLine("{0} deleted.", 
                  fullName);
            }
         }
         //  丮 Ѵ.
        newSubDir.Delete(true); 
      }
   }
}
